/*# name=OS/2 drop-in functions for Scott's Vid...() functions
    credit=Thanks to Peter Fitzsimmons for this module.
*/

#ifdef OS_2

#include <string.h>
#define INCL_NOPM
#define INCL_VIO
#define INCL_DOS
#include <os2.h>
#include <stdlib.h>
#include "dv.h"
#include "modem.h"

static BYTE Vcurattr = 7;
static USHORT Vnumcols;
static USHORT Vnumrows;
static USHORT curRow, curCol;
static char *dirty;

#define lastRow  (Vnumrows-1)
#define lastCol  (Vnumcols-1)

static PBYTE lvb = 0L;
static USHORT lvbLen;
static BYTE abStackArea[512];
/*static*/ ULONG Vsem = 0L;
static int scrolls = 0;

static void scroll1up(void);
void Vidfcur(void);

#pragma check_stack(off)

static VOID FAR _loadds uThread(void)
{
    USHORT off, len;
    int i,m;

    //DosSetPrty(PRTYS_THREAD, PRTYC_IDLETIME, 1, 0);
    while(1){
        DosSemRequest(&Vsem, -1L);
        if(lvb){
            m = FALSE;
            for(i=0; i<Vnumrows; i++){
                if(dirty[i]){
                    m = TRUE;
                    off = i * Vnumcols * 2;
                    for(len=Vnumcols; dirty[i] && i<Vnumrows; len += Vnumcols)
                        dirty[i++] = FALSE;
                    VioShowBuf(off, len*2, 0);
                    dirty[i] = FALSE;
                }
            }
            if(m){
                VioSetCurPos(curRow, curCol, 0);
            }
        }
        DosSemClear(&Vsem);
        DosSleep(1L);       // keep monitor.exe happy.
    }
}

int pascal VidOpen(int has_snow,int desqview,int dec_rows)
{
    VIOMODEINFO viomi;
    TID tid;

    viomi.cb = sizeof(viomi);
    VioGetMode(&viomi, 0);
    Vnumcols = viomi.col;
    Vnumrows = viomi.row;
    //lastRow = Vnumrows - 1;
    //lastCol = Vnumcols - 1;

    VioGetCurPos(&curRow, &curCol, 0);

#if 1
    /* Status-line? */
    if (dec_rows){
        Vnumrows--;
        while(curRow >= Vnumrows){
            VioScrollUp(0, 0, 0xFFFF, 0xFFFF, 1, " \x7", 0);
            curRow--;
        }
    }
#endif
    dirty = malloc(Vnumrows+1);
    memset(dirty, 0, Vnumrows);
    DosSemClear(&Vsem);
    VioGetBuf((PULONG) &lvb, &lvbLen, 0);
    DosCreateThread((PFNTHREAD)uThread, &tid, abStackArea + sizeof(abStackArea));
    DosSetPrty(PRTYS_THREAD, PRTYC_NOCHANGE, 1, 0);

    return(0);
    has_snow;desqview;          // keep /W3 happy
}

int pascal VidClose(int desqview)
{
    DosSemRequest(&Vsem, -1L);
    lvb = 0L;
    DosSemClear(&Vsem);
    return(0);
    desqview;                   // keep /W3 happy
}

/*
 * Many of the DosSemxxxx() calls were commented out,  because they
 * are now handled in max_out.c,  with the VLock() and VUnlock()
 * macros.
 */

int  pascal VidGotoXY(int Col,int Row, int sync)
{
    //DosSemRequest(&Vsem, -1L);
    curRow = min(Row - 1, lastRow);
    curCol = min(Col - 1, lastCol);
#ifdef SLOW
    if(sync)
        VioSetCurPos(curRow, curCol, 0);
#else
    (void)sync;
#endif
    //DosSemClear(&Vsem);
    return(0);
}

void Vidfcur(void)
{
    DosSemRequest(&Vsem, -1L);
    VioSetCurPos(curRow, curCol, 0);
    DosSemClear(&Vsem);
}

void pascal VidCls(char Attribute)
{
#if 0
    BYTE bCell[2];

    DosSemRequest(&Vsem, -1L);
    bCell[0] = 0x20;                    /* space character       */
    bCell[1] = Attribute;
    VioScrollUp(0,                      /* top row               */
        0,                              /* left column           */
        0xFFFF,                         /* bottom row            */
        0xFFFF,                         /* right column          */
        0xFFFF,                         /* number of lines       */
        bCell,                          /* cell to write         */
        0);                             /* video handle          */
    curRow = curCol = 0;
    memset(dirty, 0, Vnumrows);
    DosSemClear(&Vsem);
#else
    int i;
    //DosSemRequest(&Vsem, -1L);
    for(i=0; i<Vnumrows * Vnumcols * 2; i+=2){
        lvb[ i+0 ] = ' ';
        lvb[ i+1 ] = Attribute;
    }
    curRow = curCol = 0;
    memset(dirty, TRUE, Vnumrows);
    //DosSemClear(&Vsem);
#endif
}

void pascal VidSetAttr(char Attribute)
{
    Vcurattr = Attribute;
}

void pascal VidGetXY(int *Col,int *Row)
{
  //DosSemRequest(&Vsem, -1L);
  *Col=curCol+1;
  *Row=curRow+1;
  //DosSemClear(&Vsem);
}

int pascal VidWhereX(void)
{
  return curCol+1;
}

int pascal VidWhereY(void)
{
  return curRow+1;
}

void pascal VidCleol(void)
{
    int i;

    if(curRow < Vnumrows){
        //DosSemRequest(&Vsem, -1l);
        for(i=curCol; i<Vnumcols; i++){
            lvb[ (curRow * Vnumcols + i) * 2    ] = ' ';
            lvb[ (curRow * Vnumcols + i) * 2 + 1] = Vcurattr;
        }
        dirty[curRow] = TRUE;
        //DosSemClear(&Vsem);
    }
}

static void scroll1up(void)
{
    int i;

#if 0
    BYTE bCell[2];
    for(i=0; i<Vnumrows-1; i++)
        dirty[i] = dirty[i+1];          /* shift dirty lines by one. */

    bCell[0] = 0x20;                    /* space character       */
    bCell[1] = Vcurattr;
    VioScrollUp(0,                      /* top row               */
        0,                              /* left column           */
        0xFFFF,                         /* bottom row            */
        0xFFFF,                         /* right column          */
        1,                              /* number of lines       */
        bCell,                          /* cell to write         */
        0);                             /* video handle          */
#else
    for(i=0; i<lastRow; i++)
        memcpy(lvb + i * Vnumcols * 2, lvb + (i+1) * Vnumcols * 2, Vnumcols*2); // only works in large/compact model

    for(i=0; i<Vnumcols; i++){          // blank last line
        lvb[ (lastRow * Vnumcols + i) * 2    ] = ' ';
        lvb[ (lastRow * Vnumcols + i) * 2 + 1] = Vcurattr;
    }
    for(i=0; i<Vnumrows; i++)
        dirty[i] = TRUE;
#endif
}

/* These two MUST remain CDECL, or else we'll have to change our function ptrs */
void cdecl VidPuts(char *str)
{
    USHORT i;

    //DosSemRequest(&Vsem, -1L);
    for(i=0; str[i] ; i++){
        if(curCol > lastCol){
            curCol = 0;
            dirty[curRow++] = TRUE;
        }
        if(curRow > lastRow){
            curRow--;
            scroll1up();
            dirty[lastRow] = TRUE;
        }
        if(str[i]=='\r')
            curCol = 0;
        else if(str[i]=='\n'){
            dirty[curRow++] = TRUE;
        }
        else{
            lvb[ (curRow * Vnumcols + curCol) * 2 ] = str[i];
            lvb[ (curRow * Vnumcols + curCol) * 2 + 1 ] = Vcurattr;
            curCol++;
        }
    }
    if(curRow < Vnumrows)
        dirty[curRow] = TRUE;
    //DosSemClear(&Vsem);
}

void cdecl VidPutc(char ch)
{
    //DosSemRequest(&Vsem, -1L);
    if(curCol > lastCol){
        curCol = 0;
        dirty[curRow++] = TRUE;
    }
    if(curRow > lastRow){
        curRow--;
        scroll1up();
        dirty[lastRow] = TRUE;
    }
    if(ch=='\r')
        curCol = 0;
    else if(ch=='\n'){
        dirty[curRow++] = TRUE;
    }
    else if(ch==8 && curCol)  // backspace
        curCol--;
    else{
        lvb[ (curRow * Vnumcols + curCol) * 2 ] = ch;
        lvb[ (curRow * Vnumcols + curCol) * 2 + 1 ] = Vcurattr;
        curCol++;
    }

   if(curRow > lastRow){
       curRow--;
       scroll1up();
       dirty[lastRow] = TRUE;
   }

    if(curRow < Vnumrows)
        dirty[curRow] = TRUE;
    //DosSemClear(&Vsem);
}

int pascal VidNumRows(void)
{
  return Vnumrows;
}
int pascal VidNumCols(void)
{
  return Vnumcols;
}

char pascal VidGetAttr(void)
{
  return Vcurattr;
}

void IoPause(void)
{
    ComPause(hcModem);
    DosSemRequest(&Vsem, -1L);    /* suspend video thread, if active */
}

void IoResume(void)
{
    DosSemClear(&Vsem);    /* resume video thread */
    ComResume(hcModem);
}
#endif

